/* 
   22/10/2003
   Programa de pruenba para el algoritmo de la linea en 3D
*/

#include <stdio.h>
#include <malloc.h>
#include <math.h>
#include "linefun.h"
#define N 8
#define M 5
#define gr_tone 200

int main()
{
  int i,j,k,l,incrang,cf,V0[3],V2[3];
  double px,py,pz,n,tetha,phi,cf_d;
  unsigned char ***space;

  space=(unsigned char ***)malloc(N*sizeof(unsigned char **));
  if(space==NULL)
	return(-1);
  for(i=0;i<N;i++){
	space[i]=(unsigned char **)malloc(N*sizeof(unsigned char *));
	if(space[i]==NULL)
	  return(-1);
	for(j=0;j<N;j++){
	  space[i][j]=(unsigned char *)malloc(N*sizeof(unsigned char ));
	  if(space[i][j]==NULL)
		return(-1);
	  for(k=0;k<N;k++)
		space[i][j][k]=0;
	}
  }
  
  cf=N/2-M/2;
  cf_d=(double)cf;
  
  for(i=0;i<M;i++)
	for(j=0;j<M;j++)
	  for(k=0;k<M;k++)
		space[i+cf][j+cf][k+cf]=gr_tone;
  
  incrang=5;
  cf=N/2;
  V0[0]=V0[1]=V0[2]=N/2;
  l=150;
  n=360/incrang;

  printf("Cubo de tamao %dX%dX%d en un buffer de tamao %dX%dX%d \ncon centro en %d,%d, %d\n",M,M,M,N,N,N,cf,cf,cf);
  for(i=0;i<n/2;i++){
	tetha=(double)(i*incrang)*ANGTORAD;
	for(j=0;j<n;j++){
	  phi=(double)(j*incrang)*ANGTORAD;
	  px=cf_d+sin(phi)*cos(tetha)*(double)l;
	  py=cf_d+sin(phi)*sin(tetha)*(double)l;
	  pz=cf_d+cos(phi)*(double)l;
	  
	  /*printf("angulo phi %.0f tetha %.0f punto de choque %d,%d,%d\n",
		phi*RADTOANG,tetha*RADTOANG,Round(px),Round(py),Round(pz) );*/
	  CohenSutherlandLineClip_3D( &cf_d, &cf_d, &cf_d, &px, &py, &pz, 0.0, 
								  (double)(N-1), 0.0, (double)(N-1), 0.0, 
								  (double)(N-1));
	  
	  printf("Clipping  angulo phi %.0f tetha %.0f punto de choque %d,%d,%d\n",
			 phi*RADTOANG,tetha*RADTOANG,Round(px),Round(py),Round(pz) );
	  MidPointLine3D_ang_val( V0,V2,phi,tetha,space,gr_tone);
	  printf("Mid_pt3D  angulo phi %.0f tetha %.0f punto de choque %d,%d,%d\n",
			 phi*RADTOANG,tetha*RADTOANG,V2[0],V2[1],V2[2]);
	  
	}

  }
  return (1);
}
