#include "linefun.h"
#include <math.h>
#include <stdlib.h>



void MidPointLine3D_ang_val(int *V0, int *V2, double phi, double theta,
							unsigned char ***spc, int value)
{
  int dx,dy,dz,d1,d2,inc1,inc2,inc1N,inc2N,*max,*mid,*min,mid_i; 
  int x2_1,y2_1,x2_2,y2_2,*px,*py,incE,incNE,dmax,dmid,dmin,auxdmx,auxdmd,auxdmn;
  int d2_x,d2_y,d2_d,top,V1[3],xaux,yaux,zaux,x,y,z,*px_aux,*py_aux;
  int *max_aux,*mid_aux,*min_aux;
  unsigned char flg;
  
  V1[0]=V0[0]+Round(150.0*sin(phi)*cos(theta));
  V1[1]=V0[1]+Round(150.0*sin(phi)*sin(theta));
  V1[2]=V0[2]+Round(150.0*cos(phi));
  
  flg=0;

  dx=abs(V1[0]-V0[0]);
  dy=abs(V1[1]-V0[1]);
  dz=abs(V1[2]-V0[2]);
  
  

  xaux=x=V0[0]; yaux=y=V0[1];zaux=z=V0[2];
    
  if(!dx||!dy||!dz)
    {
      if(dx==0){
		x2_1=V0[1]; y2_1=V0[2];
		x2_2=V1[1]; y2_2=V1[2];
		px=&y; py=&z;
		px_aux=&yaux; py_aux=&zaux;
      }
      else if(dy==0){
		x2_1=V0[0]; y2_1=V0[2];
		x2_2=V1[0]; y2_2=V1[2];
		px=&x; py=&z;
		px_aux=&xaux; py_aux=&zaux;
      }
      else{
		x2_1=V0[0]; y2_1=V0[1];
		x2_2=V1[0]; y2_2=V1[1];
		px=&x; py=&y;
		px_aux=&xaux; py_aux=&yaux;
      }
      
      d2_x=abs(x2_2-x2_1);
      d2_y=abs(y2_2-y2_1);
      
      if(d2_x==0 && d2_y==0)
		return;
      
      if(d2_y<d2_x){
		d2_d=2*d2_y-d2_x;
		incE=2*d2_y;
		incNE=2*(d2_y-d2_x);
      }
      else{
		d2_d=2*d2_x-d2_y;
		incE=2*d2_x;
		incNE=2*(d2_x-d2_y);
      }
      
      
      (*px_aux)=(*px); (*px)=x2_1; (*py_aux)=(*py); (*py)=y2_1;
      
      xaux=x; yaux=y; zaux=z;
	  
      d2_x=x2_2-x2_1;
      d2_y=y2_2-y2_1;
      
      
      if(d2_y==0){
		if(d2_x>0){/* Caso 1 2D */
		  while(!flg){
			(*px_aux)=(*px); (*px)++;
			
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
		  }
		}
      	else{ /* Caso 5 2D */
		  while(!flg){
			(*px_aux)=(*px); (*px)--;
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
			
		  }
		}
      }
      else if(d2_x==0){
		if(d2_y>0){ /* Caso 3 2D */
		  while(!flg){
			(*py_aux)=(*py); (*py)++;
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
			
		  }
		}
		else{ /* Caso 7 2D */
		  while(!flg){
			(*py_aux)=(*py); (*py)--;
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
			
		  }
		}
      }
      
      /* Casos 2,4,6 y 8 */
      else if(d2_x==d2_y){ /*Caso 2 y6 */
		if(d2_x>0){
		  while(!flg){ /* Caso 2 2D */
			(*px_aux)=(*px); (*px)++; (*py_aux)=(*py); (*py)++;
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
			
		  }
		}
		else{ /* Caso 6 2D */
		  while(!flg){ 
			(*px_aux)=(*px); (*px)--; (*py_aux)=(*py); (*py)--;
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
			
		  }
		}
      }
      else if(-d2_x==d2_y){ /* Caso 4 y 8 */
		if(d2_x>0){
		  while(!flg){ /* Caso 4 2D */
			(*px_aux)=(*px); (*px)++; (*py_aux)=(*py); (*py)--;
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
			
		  }
		}
		else{ /*  Caso 8 2D */
		  while(!flg){ 
			(*px_aux)=(*px); (*px)--; (*py_aux)=(*py); (*py)++;
			if(spc[x][y][z]!=value){
			  x=xaux; y=yaux; z=zaux;
			  flg=1;
			}
		  }
		}
      }
      else if(d2_x>0){ /* Casos 9,10,15 y 16 */
		if(d2_y>0){/*Casos 9 y 10 */
		  if(d2_x>d2_y){/* Caso 9 2D */
			while(!flg){
			  if(d2_d<=0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*py_aux)=(*py); (*py)++;
			  }
			  (*px_aux)=(*px); (*px)++;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		  else{/* Caso 10 2D */
			while(!flg){
			  if(d2_d<=0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*px_aux)=(*px); (*px)++;
			  }
			  (*py_aux)=(*py); (*py)++;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		}
		else{/* Casos 15 y 16 */
		  if(d2_x<-d2_y){/* Caso 15 2D */
			while(!flg){
			  if(d2_d<0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*px_aux)=(*px); (*px)++;
			  }
			  (*py_aux)=(*py); (*py)--;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		  else{/* Caso 16 2D */
			while(!flg){
			  if(d2_d<0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*py_aux)=(*py); (*py)--;
			  }
			  (*px_aux)=(*px); (*px)++;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		}
      }
      else{/* Casos 11,12,13 y 14 */
		if(d2_y>0){/* Casos 11 y 12 */
		  if(-d2_x>d2_y){/* Caso 12 2D */
			while(!flg){
			  if(d2_d<=0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*py_aux)=(*py); (*py)++;
			  }
			  (*px_aux)=(*px); (*px)--;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		  else{/* Caso 11 2D */
			while(!flg){
			  if(d2_d<=0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*px_aux)=(*px); (*px)--;
			  }
			  (*py_aux)=(*py); (*py)++;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		}
		else{/* Casos 13 y 14 */
		  if(d2_x<d2_y){/* Caso 13 2D */
			while(!flg){
			  if(d2_d<0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*py_aux)=(*py); (*py)--;
			  }
			  (*px_aux)=(*px); (*px)--;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		  else{/* Caso 14 2D */
			while(!flg){
			  if(d2_d<0)
				d2_d+=incE;
			  else{
				d2_d+=incNE;
				(*px_aux)=(*px); (*px)--;
			  }
			  (*py_aux)=(*py); (*py)--;
			  if(spc[x][y][z]!=value){
				x=xaux; y=yaux; z=zaux;
				flg=1;
			  }
			}
		  }
		}
      }
    }
  else{
    if(dx>=dy&&dx>=dz){
      dmax=V1[0]-V0[0];
      max=&x; max_aux=&xaux;
      top=V1[0];
      if(dy>=dz){
		dmid=V1[1]-V0[1];
		mid=&y; mid_aux=&yaux;
		dmin=V1[2]-V0[2];
		min=&z; min_aux=&zaux;
      }
      else{
		dmid=V1[2]-V0[2];
		mid=&z; mid_aux=&zaux;
		dmin=V1[1]-V0[1];
		min=&y; min_aux=&yaux;
      }
    }
    else if(dy>dx&&dy>=dz){
      dmax=V1[1]-V0[1];
      max=&y; max_aux=&yaux;
      top=V1[1];
      if(dx>=dz){
		dmid=V1[0]-V0[0];
		mid=&x; mid_aux=&xaux;
		dmin=V1[2]-V0[2];
		min=&z; min_aux=&zaux;
      }
      else{
		dmid=V1[2]-V0[2];
		mid=&z; mid_aux=&zaux;
		dmin=V1[0]-V0[0];
		min=&x; min_aux=&xaux;
      }
    }
    else {
      dmax=V1[2]-V0[2];
      max=&z; max_aux=&zaux;
      top=V1[2];
      if(dx>=dy){
		dmid=V1[0]-V0[0];
		mid=&x; mid_aux=&xaux;
		dmin=V1[1]-V0[1];
		min=&y; min_aux=&yaux;
      }
      else{
		dmid=V1[1]-V0[1];
		mid=&y; mid_aux=&yaux;
		dmin=V1[0]-V0[0];
		min=&x; min_aux=&xaux;
      }
    }
	
    auxdmx=abs(dmax);
    auxdmd=abs(dmid);
    auxdmn=abs(dmin);
    
    d1=2*auxdmd-auxdmx;
    inc1=2*auxdmd;
    inc1N=2*(auxdmd-auxdmx);
	
    d2=2*auxdmn-auxdmd;
    inc2=2*auxdmn;
    inc2N=2*(auxdmn-auxdmd);
	
	
    xaux=x=V0[0]; yaux=y=V0[1]; zaux=z=V0[2];
    
	while(!flg){
      mid_i=0;
      /* Casos 2,4,6 y 8 */
      if(dmax==dmid){ /* Caso 2 y 6 */
		if(dmax>0){/* Caso 2 */
		  (*max_aux)=(*max); (*max)++; (*mid_aux)=(*mid); (*mid)++; mid_i=1;
		}
		else{ /* Caso 6 */
		  (*max_aux)=(*max); (*max)--; (*mid_aux)=(*mid); (*mid)--; mid_i=-1;
		}
      }
      else if(-dmax==dmid){ /* Caso 4 y 8 */
		if(dmax>0){/* Caso 4 */
		  (*max_aux)=(*max); (*max)++; (*mid_aux)=(*mid); (*mid)--; mid_i=-1;
		}
		else{ /* Caso 8 */
		  (*max_aux)=(*max); (*max)--; (*mid_aux)=(*mid); (*mid)++; mid_i=1;
		}
      }
      
      else if(dmid>0){ /* Casos 9,10,15 y 16 */
		if(dmax>0){/* Casos 9 y 10 */
		  /* Caso 10 */
		  if(d1<=0)
			d1+=inc1;
		  else{
			d1+=inc1N;
			(*mid_aux)=(*mid); (*mid)++; mid_i=1;
		  }
		  (*max_aux)=(*max); (*max)++;
		}
		else{/* Casos 15 y 16 */
		  /* Caso 15 */
		  if(d1<0)
			d1+=inc1;
		  else{
			d1+=inc1N;
			(*mid_aux)=(*mid); (*mid)++; mid_i=1;
		  }
		  (*max_aux)=(*max); (*max)--;
		}
      }
      else{/* Casos 11,12,13 y 14 */
		if(dmax>0){/* Casos 11 y 12 */
		  /* Caso 11 */
		  if(d1<=0)
			d1+=inc1;
		  else{
			d1+=inc1N;
			(*mid_aux)=(*mid); (*mid)--;mid_i=-1;
		  }
		  (*max_aux)=(*max); (*max)++;
		}
		else{/* Casos 13 y 14 */
		  /* Caso 13 */
		  if(d1<0)
			d1+=inc1;
		  else{
			d1+=inc1N;
			(*mid_aux)=(*mid); (*mid)--; mid_i=-1;
		  }
		  (*max_aux)=(*max); (*max)--; 
		}
      }
      if(mid_i){
		if(dmid==dmin){ /* Caso 2 y 6 */
		  if(dmid>0){/* Caso 2 */
			(*min_aux)=(*min); (*min)++; 
		  }
		  else{ /* Caso 6 */
			(*min_aux)=(*min); (*min)--;
		  }
		}
		else if(-dmid==dmin){ /* Caso 4 y 8 */
		  if(dmid>0){/* Caso 4 */
			(*min_aux)=(*min); (*min)--; 	  
		  }
		  else{ /* Caso 8 */
			(*min_aux)=(*min); (*min)++;
		  }
		}
		
		else if(dmid>0){ /* Casos 9,10,15 y 16 */
		  if(dmin>0){/* Casos 9 y 10 */
			/* Caso 9 */
			if(d2<=0)
			  d2+=inc2;
			else{
			  d2+=inc2N;
			  (*min_aux)=(*min); (*min)++;
			}
		  }
		  else{/* Casos 15 y 16 */
			/* Caso 16 */
			if(d2<0)
			  d2+=inc2;
			else{
			  d2+=inc2N;
			  (*min_aux)=(*min); (*min)--;
			}
		  }
		}
		else{/* Casos 11,12,13 y 14 */
		  if(dmin>0){/* Casos 11 y 12 */
			/* Caso 12 */
			if(d2<=0)
			  d2+=inc2;
			else{
			  d2+=inc2N;
			  (*min_aux)=(*min); (*min)++;
			}
		  }
		  else{/* Casos 13 y 14 */
			/* Caso 14 */
			if(d2<0)
			  d2+=inc2;
			else{
			  d2+=inc2N;
			  (*min_aux)=(*min); (*min)--;
			}
		  }
		}
      }
      
      if(spc[x][y][z]!=value){
		x=xaux; y=yaux; z=zaux;
		flg=1;
	  }
	}
  }
  V2[0]=x; V2[1]=y; V2[2]=z;
}

void CohenSutherlandLineClip_3D(double *x0, double *y0, double *z0, double *x1,
								double *y1, double *z1, double xmin,
								double xmax,double ymin, double ymax, 
								double zmin, double zmax)
	 /** Cohen-Sutherland clipping algorithm for line P0=(x0, y0) to
		 P1 = (x1, y1) and clip rectangle with diagonal from
		 (xmin, ymin) to (xmax, ymax) **/
{
  /** Outcode for P0, P1, and whatever point lies outside the clip
      rectabgle **/
  double x, y, z;
  outcode outcode0, outcode1, outcodeOut;
  boolean accept=FALSE, done=FALSE;
  
  outcode0 = CompOutCode_3D( *x0, *y0, *z0, xmin, xmax, ymin, ymax, zmin, zmax );
  outcode1 = CompOutCode_3D( *x1, *y1, *z1, xmin, xmax, ymin, ymax, zmin, zmax );
  
  do {
    if( !(outcode0|outcode1) ) {   /* Trivial accept and exit */
      accept=TRUE; done=TRUE;
    }
    else if( outcode0&outcode1) /* Logical AND is true, so trivial */
      done = TRUE;            /* reject and exit                 */
	else {
      /* Failed both tests, so calculate the line segment to clip
		 from an outside point to an intersection with clip edge */
      
      /* At least one endpoint is outside the clip rectangle; pick it */
      outcodeOut = outcode0 ? outcode0 : outcode1;
      /* Now find the intersecion point */
      if ( outcodeOut & TOP ) {
		x = *x0 + (*x1-*x0)*(ymax - *y0)/(*y1 - *y0);
		z = *z0 + (*z1-*z0)*(ymax - *y0)/(*y1 - *y0);
		y = ymax;
      }
      else if (outcodeOut & BOTTOM) {
		x = *x0 + (*x1-*x0)*(ymin - *y0)/(*y1 - *y0);
		z = *z0 + (*z1-*z0)*(ymin - *y0)/(*y1 - *y0);
		y = ymin;
	  }
      else if (outcodeOut & RIGHT) {
		y = *y0 + (*y1-*y0)*(xmax - *x0)/(*x1 - *x0);
		z = *y0 + (*z1-*z0)*(xmax - *x0)/(*x1 - *x0);
		x = xmax;
	  }
      else if (outcodeOut & LEFT){
		y = *y0 + (*y1-*y0)*(xmin - *x0)/(*x1 - *x0);
		z = *y0 + (*z1-*z0)*(xmin - *x0)/(*x1 - *x0);
		x = xmin;
	  }
	  else if (outcodeOut & FRONT) {
		y = *y0 + (*y1-*y0)*(zmax - *z0)/(*z1 - *z0);
		x = *x0 + (*x1-*x0)*(zmax - *z0)/(*z1 - *z0);
		z = zmax;
	  }
	  else{
		y = *y0 + (*y1-*y0)*(zmin - *z0)/(*z1 - *z0);
		x = *x0 + (*x1-*x0)*(zmin - *z0)/(*z1 - *z0);
		z = zmin;
	  }

      if ( outcodeOut == outcode0 ) {
		*x0 = x;
		*y0 = y;
		*z0 = z;
		outcode0 = CompOutCode_3D( *x0, *y0, *z0, xmin, xmax, ymin, ymax, zmin, zmax );
	  }
      else {
		*x1 = x;
		*y1 = y;
		*z1 = z;
		outcode1 = CompOutCode_3D( *x1, *y1, *z1, xmin, xmax, ymin, ymax, zmin, zmax);
      }
    }
  } while( done==FALSE );
}

outcode CompOutCode_3D(double x, double y, double z,double xmin, double xmax,
					   double ymin, double ymax, double zmin, double zmax )
{
  outcode code=0;
  if ( y > ymax ) 
    code |= TOP;
  else if( y < ymin )
    code |= BOTTOM;
  if ( x > xmax )
    code |= RIGHT;
  else if ( x < xmin )
    code |= LEFT;
  else if ( z > zmax )
	code |= FRONT;
  else if ( z < zmin )
	code |= BEHIND;
  return code;
}
